import { setHidden, globals, $$, observe, $O } from './shared/815e560c.mjs';

const shims = [
  [Object, ["keys", "values", "entries"]],
  [Array, ["from"]]
];
shims.forEach(([namespace, keys]) => keys.forEach((key) => {
  const fn = namespace[key];
  const shim = (...args) => {
    const target = args[0] && args[0][$$];
    if (target) {
      observe(target, $O);
      args[0] = target;
    }
    return fn(...args);
  };
  setHidden(shim, "name", fn.name);
  Object.defineProperty(namespace, key, {
    get: () => globals.observe ? shim : fn
  });
}));

export { shims };
//# sourceMappingURL=shims.mjs.map
